<template>
  <div class="switcher-container">
    <div
      v-for="rowSources, rowIndex in openedSources"
      :key="rowIndex"
      :class="{ 'separated-row': rowIndex > 0 }"
      class="canvas-row-container"
      :style="`height: ${100 / openedSources.length}%`"
    >
      <div
        v-for="{source, scale, snappableWave}, sourceIndex in rowSources"
        :key="`${sourceIndex} ${source.id}`"
        class="canvas-col-container"
        :class="{ 'separated-col': sourceIndex > 0 }"
        :style="`width: ${100 / rowSources.length}%`"
      >
        <canvas-switcher-menu>
          <!-- The dropdown menu to select a source -->
          <canvas-switcher-select
            v-if="sources.length > 1"
            :value="source"
            :items="sources"
            @input="(source) => setSource(source, rowIndex, sourceIndex)"
          />
          <!-- Scale down button -->
          <canvas-switcher-button
            v-if="!source.shouldSnap"
            icon="mdi-magnet"
            :togglable="true"
            :tooltip="$t('canvas-switcher.tooltip.snap')"
            @click="() => toggleSnap(rowIndex, sourceIndex)"
          />
          <canvas-switcher-button
            icon="mdi-magnify-minus"
            :tooltip="$t('canvas-switcher.tooltip.scaleDown')"
            @click="() => updateZoom(-1, rowIndex, sourceIndex)"
          />
          <canvas-switcher-button
            icon="mdi-magnify-plus"
            :tooltip="$t('canvas-switcher.tooltip.scaleUp')"
            @click="() => updateZoom(1, rowIndex, sourceIndex)"
          />
          <template v-if="severalSources">
            <canvas-switcher-add-button
              v-if="rowIndex === 0 && !tooManySourcesInRow(rowIndex)"
              @add="(dir) => add(rowIndex, sourceIndex, dir)"
            />
            <canvas-switcher-add-button
              v-if="!tooManyRows"
              direction="vertical"
              @add="(dir) => add(rowIndex, sourceIndex, dir)"
            />
          </template>
          <canvas-switcher-button
            v-if="severalOpenedSources"
            icon="mdi-close"
            :tooltip="$t('canvas-switcher.tooltip.close')"
            @click="() => remove(rowIndex, sourceIndex)"
          />
        </canvas-switcher-menu>
        <div class="canvas-slot">
          <slot
            :source="source"
            :scale="scale"
            :index="(sourceIndex + 1) + rowIndex * 10"
            :snappable-wave="snappableWave"
          />
        </div>
      </div>
    </div>
  </div>
</template>
<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator';
import type { Audio, Source } from '@/data';
import { SourceType } from '@/data';
import Zoom from '@/logic/Zoom';
import CanvasSwitcherButton from './CanvasSwitcherButton.vue';
import CanvasSwitcherSelect from './CanvasSwitcherSelect.vue';
import CanvasSwitcherMenu from './CanvasSwitcherMenu.vue';
import CanvasSwitcherAddButton from './CanvasSwitcherAddButton.vue';

const MAX_DISPLAYED_SOURCES_BY_ROW = 2;
const MAX_DISPLAYED_ROWS = 2;

export enum CanvasLayoutDirection {
  Vertical = 'vertical',
  Horizontal = 'horizontal'
}

interface SelectedSource {
  source: Source;
  scale: Zoom;
  snappableWave: boolean;
}

@Component({
  components: {
    CanvasSwitcherButton,
    CanvasSwitcherSelect,
    CanvasSwitcherMenu,
    CanvasSwitcherAddButton,
  },
})
export default class CanvasSwitcher extends Vue {
  @Prop()
  sources!: Source[];

  private openedSources: Array<SelectedSource[]> = [];

  @Prop({ required: false, type: Array, default: [] })
  defaultSources!: Array<Array<Source>>;

  private get severalSources() : boolean {
    return this.sources.length > 1;
  }

  private get tooManyRows(): boolean {
    return this.rowsCount >= MAX_DISPLAYED_ROWS;
  }

  private get severalOpenedSources() : boolean {
    return this.rowsCount > 1 || this.columnsCountForRow(0) > 1;
  }

  private tooManySourcesInRow(rowIndex: number): boolean {
    return this.columnsCountForRow(rowIndex) >= MAX_DISPLAYED_SOURCES_BY_ROW;
  }

  private get rowsCount() : number {
    return this.openedSources.length;
  }

  private columnsCountForRow(rowIndex: number) : number {
    return this.openedSources[rowIndex].length;
  }

  mounted() {
    if (this.sources.length === 0) throw new Error('No Sources in Switcher');

    if (this.defaultSources.length > 0) {
      for (let y = 0; y < this.defaultSources.length; y += 1) {
        this.add(y, 0, CanvasLayoutDirection.Vertical);
        for (let x = 0; x < this.defaultSources[y].length; x += 1) {
          if (x > 0) {
            this.add(y, x, CanvasLayoutDirection.Horizontal);
          }
          this.setSource(this.defaultSources[y][x], y, x);
        }
      }
    } else {
      this.add(0, 0);
    }
  }

  private toggleSnap(row: number, col: number) {
    this.openedSources[row][col].snappableWave = !this.openedSources[row][col].snappableWave;
  }

  public updateWaveform(track: Audio) {
    let founded = false;
    for (let i = 0; i < this.openedSources.length; i += 1) {
      for (let j = 0; j < this.openedSources[i].length; j += 1) {
        const currentSource = this.openedSources[i][j];
        if (
          currentSource.source.track?.youtubeId
          && currentSource.source.track.youtubeId !== track.youtubeId
        ) {
          const newSource = this.sources.find((s) => s.track?.youtubeId === track.youtubeId);

          const scale = new Zoom();
          const snappableWave = false;
          Vue.set(this.openedSources[i], j, { source: newSource, scale, snappableWave });

          founded = true;
          break;
        }
      }
      if (founded) { break; }
    }
  }

  private setSource(source: Source, row: number, col: number) {
    if (source.type === SourceType.AudioImage) {
      this.$emit('set-youtube-track', source.track);
    }

    const scale = new Zoom();
    const snappableWave = false;
    const zoom = new Zoom();
    Vue.set(this.openedSources[row], col, {
      source, scale, snappableWave, zoom,
    });
  }

  private add(row: number, col: number, direction?: CanvasLayoutDirection) {
    const selectedSource: SelectedSource = {
      source: this.sources[0],
      scale: new Zoom(),
      snappableWave: false,
    };
    if (direction && direction === CanvasLayoutDirection.Horizontal) {
      this.openedSources[row].splice(col, 0, selectedSource);
    } else if (this.openedSources.length >= row) {
      this.openedSources.splice(row, 0, [selectedSource]);
    } else {
      this.openedSources.push([selectedSource]);
    }
  }

  private remove(row: number, col: number) {
    if (this.openedSources[row].length === 1) {
      this.openedSources.splice(row, 1);
    } else {
      this.openedSources[row].splice(col, 1);
    }
  }

  private updateZoom(value: number, rowIndex: number, sourceIndex: number) {
    const { source, scale } = this.openedSources[rowIndex][sourceIndex];
    if (source.shouldSnap) {
      source.zoom.exponent += value;
    } else {
      scale.exponent += value;
    }

    this.$nextTick(() => {
      this.$nextTick();
    });
  }
}
</script>
<style scoped lang="scss">
.switcher-container {
  max-width: 100vw;
  display: flex;
  flex-direction: column;
}
.canvas {
  &-row-container {
    display: flex;
    width: 100%;
    height: 100%;
    &.separated-row {
      border-top: 2px solid #607d8b;
    }
  }
  &-col-container {
    display: flex;
    flex-direction: column;
    width: 100%;
    height: 100%;
    &:not(:last-child) {
      resize: horizontal;
      overflow: hidden;
    }
    &.separated-col {
      border-left: 2px solid #607d8b;
    }
  }
  &-slot {
    box-shadow: 0 4px 4px 2px rgba(0, 0, 0, 0.14);
    height: 100%;
    min-height: 0;
  }
}
</style>
